package com.saini.testingchat;

import org.jivesoftware.smack.roster.Roster;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.saini.testingchat.manager.XmppManager;
import com.saini.testingchat.service.MainService;

@SuppressWarnings("deprecation")
public class LoogedInActivity extends ActionBarActivity {
	Context context;
	String TAG = "LoogedInActivity";
	XmppManager xmmpMan = new XmppManager();
	LoginSatusReceiver2 loginRecevier;
	TextView textView;
	EditText toTextBox;
	Roster roster;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		context = LoogedInActivity.this;
		setContentView(R.layout.activity_looged_in);
		loginRecevier = new LoginSatusReceiver2();
		registerReceiver(loginRecevier, new IntentFilter("ServiceIsTerminated"));
		textView = (TextView) findViewById(R.id.textView1);
		toTextBox = (EditText) findViewById(R.id.editText1);
		xmmpMan.init();
		xmmpMan.printRoster();
		textView.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				xmmpMan.sendMessage(toTextBox.getText().toString().trim(),
						"My FIrst MEssge");
				Log.d(TAG, "Message sent from Activity");
			}
		});
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.looged_in, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_logout) {

			if (xmmpMan.init()) {

				if (stopService(new Intent(context, MainService.class))) {
					Log.d(TAG, "Logout | Service termination start .");
				} else {
					Log.d(TAG, "Not able to stop service sorry .");
					Toast.makeText(
							context,
							"Not able to stop service now.\n Try Again after some time.",
							Toast.LENGTH_LONG).show();

				}
			} else {
				Log.d(TAG, "Not able to connect with server.");
				Toast.makeText(
						context,
						"Not able to connect application server.\n Kindly contact with admin.",
						Toast.LENGTH_LONG).show();
			}

		}
		return super.onOptionsItemSelected(item);
	}

	private class LoginSatusReceiver2 extends BroadcastReceiver {
		@Override
		public void onReceive(Context context, Intent intent) {
			String action = intent.getAction();
			if (action.equals("ServiceIsTerminated")) {
				Log.d(TAG, "Service is Terminated,, Sorry");

				Intent mainIntent = new Intent(context, MainActivity.class);
				overridePendingTransition(0, 0);
				mainIntent.addFlags(Intent.FLAG_ACTIVITY_NO_ANIMATION);
				finish();
				overridePendingTransition(0, 0);
				startActivity(mainIntent);

			}
		}
	};

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		unregisterReceiver(loginRecevier);
	}

}
