package com.saini.testingchat;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.saini.testingchat.service.MainService;
import com.saini.testingchat.util.ChatUtils;

public class MainActivity extends Activity {
	Button loginButton;
	EditText userNameFeild, passwordFeild;
	String userName, password;
	Context context;
	SharedPreferences sharedpreferences;
	String TAG = "MainActivity";
	AlertDialog alertDialog;

	LoginSatusReceiver loginRecevier;

	@SuppressLint("NewApi")
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		context = MainActivity.this;

		sharedpreferences = PreferenceManager
				.getDefaultSharedPreferences(context);
		String username = sharedpreferences.getString("user", "");
		String passwrd = sharedpreferences.getString("pwd", "");
		Log.d(TAG, "user & pass for login :" + username + "|" + passwrd);
		if (!TextUtils.isEmpty(username) && !TextUtils.isEmpty(passwrd)) {
			Intent loggedIntent = new Intent(context, LoogedInActivity.class);
			overridePendingTransition(0, 0);
			loggedIntent.addFlags(Intent.FLAG_ACTIVITY_NO_ANIMATION);
			finish();
			overridePendingTransition(0, 0);
			startActivity(loggedIntent);
		}

		loginRecevier = new LoginSatusReceiver();
		registerReceiver(loginRecevier, new IntentFilter("LoginDoneInPSPChat"));
		registerReceiver(loginRecevier, new IntentFilter("NoXmppInitInPSPChat"));
		registerReceiver(loginRecevier, new IntentFilter(
				"NotAbleToLoginInPSPChat"));

		setContentView(R.layout.activity_main);

		loginButton = (Button) findViewById(R.id.loginButton);
		userNameFeild = (EditText) findViewById(R.id.usernameBox);
		passwordFeild = (EditText) findViewById(R.id.passwordBox);
		loginButton.setOnClickListener(new LoginButtonListener());

	}

	class LoginButtonListener implements OnClickListener {

		@SuppressWarnings("deprecation")
		@Override
		public void onClick(View v) {
			// TODO Auto-generated method stub
			userName = userNameFeild.getText().toString().trim();
			password = passwordFeild.getText().toString().trim();
			boolean readyToLogin = false;
			if (TextUtils.isEmpty(userName)) {
				userNameFeild.setText("");
				Toast.makeText(context, "Please Enter Username.",
						Toast.LENGTH_SHORT).show();
				readyToLogin = false;
			} else {
				if (TextUtils.isEmpty(password)) {
					passwordFeild.setText("");
					readyToLogin = false;
					Toast.makeText(context, "Please Enter Password.",
							Toast.LENGTH_SHORT).show();
				} else {
					readyToLogin = true;
				}
			}

			if (readyToLogin) {
				if (ChatUtils.isNetworkAvailable(context)) {
					Log.v(TAG, "|" + userName + "|" + password + "| in Login");
					// /////Start
					Intent loginServiceIntent = new Intent(context,
							MainService.class);
					loginServiceIntent.putExtra("unm", userName);
					loginServiceIntent.putExtra("pwd", password);
					startService(loginServiceIntent);

				} else {
					alertDialog = new AlertDialog.Builder(context).create();
					if (alertDialog != null) {
						// Setting Dialog Title
						alertDialog
								.setTitle("No Internet Connection Available.");
						alertDialog.setCanceledOnTouchOutside(false);

						// Setting Dialog Message
						alertDialog.setMessage("Kindly Connect With Internet.");

						// Setting Icon to Dialog
						alertDialog.setIcon(R.drawable.no_internet);
						alertDialog.setButton("OK",
								new DialogInterface.OnClickListener() {

									@Override
									public void onClick(DialogInterface dialog,
											int which) {
										// TODO Auto-generated method stub
										alertDialog.dismiss();
									}
								});
						// Showing Alert Message
						alertDialog.show();
					} else {
						Log.d(TAG, "Dials is null");
					}
				}
			}
		}
	}

	private class LoginSatusReceiver extends BroadcastReceiver {
		@Override
		public void onReceive(Context context, Intent intent) {
			String action = intent.getAction();
			if (action.equals("LoginDoneInPSPChat")) {
				sharedpreferences = PreferenceManager
						.getDefaultSharedPreferences(context);
				String username = sharedpreferences.getString("user", "");
				String passwrd = sharedpreferences.getString("pwd", "");
				Log.d(TAG, "user & pass for login in BroadCast reciver:"
						+ username + "|" + passwrd);
				if (!TextUtils.isEmpty(username) && !TextUtils.isEmpty(passwrd)) {
					Intent loggedIntent = new Intent(context,
							LoogedInActivity.class);
					overridePendingTransition(0, 0);
					loggedIntent.addFlags(Intent.FLAG_ACTIVITY_NO_ANIMATION);
					finish();
					overridePendingTransition(0, 0);
					startActivity(loggedIntent);
				}
			} else if (action.equals("NoXmppInitInPSPChat")) {
				// action for phone state changed
				Toast.makeText(
						context,
						"Not able to connect with application server\nKindly contact with admin",
						Toast.LENGTH_LONG).show();
			} else if (action.equals("NotAbleToLoginInPSPChat")) {
				// action for phone state changed
				Toast.makeText(context,
						"Not able to Login.\nUser in not Authenticated.",
						Toast.LENGTH_LONG).show();
			}
		}
	};

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		unregisterReceiver(loginRecevier);
	}

}
