package com.saini.testingchat.service;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.text.TextUtils;
import android.util.Log;

import com.saini.testingchat.manager.XmppManager;
import com.saini.testingchat.util.ChatUtils;

public class MainService extends Service {
	XmppManager xmmpMan;
	private String TAG = "MainService";
	boolean login = false;

	@Override
	public void onCreate() {
		// TODO Auto-generated method stub
		super.onCreate();

		Log.d(TAG, "onCreate Service:");
	}

	@Override
	public void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		Log.d(TAG, "onDestroy Service:");
		xmmpMan.destroy();

		Log.d(TAG, "Check for Connection after LOgout : "
				+ xmmpMan.getConnection().getUser());
		xmmpMan = null;
		ChatUtils.clearSharedPrefs(this);
		Intent intnt = new Intent();
		intnt.setAction("ServiceIsTerminated");
		sendBroadcast(intnt);
		stopSelf();
	}

	@Override
	public IBinder onBind(Intent intent) {
		// TODO Auto-generated method stub

		return null;
	}

	public int onStartCommand(Intent intent, int flags, int startId) {
		Log.d(TAG, "onStartCommand started with Flags:" + String.valueOf(flags)
				+ " StartID:" + String.valueOf(startId));
		xmmpMan = new XmppManager();
		try {
			if (xmmpMan.init()) {

				if (null != intent) {
					String username = intent.getStringExtra("unm");
					String passwrd = intent.getStringExtra("pwd");
					Log.d(TAG,
							"fetched from Intent in Service user & pass for login :"
									+ username + "|" + passwrd);
					if (!TextUtils.isEmpty(username)
							&& !TextUtils.isEmpty(passwrd)) {
						login = xmmpMan.performLogin(username, passwrd);
						if (login) {
							ChatUtils.setPasswordFromSharedPrefs(this, passwrd);
							ChatUtils
									.setUserNameFromSharedPrefs(this, username);

							Log.d(TAG, "Login DOne");
							xmmpMan.registerIncomingMessageListener();
							xmmpMan.registerIncomingPackateListener();

						} else {

							Intent intnt = new Intent();
							intnt.setAction("NotAbleToLoginInPSPChat");
							sendBroadcast(intnt);
							stopSelf();
						}
					} else {
						stopSelf();
					}
				} else {

					String username = ChatUtils
							.getUserNameFromSharedPrefs(this);
					String passwrd = ChatUtils.getPasswordFromSharedPrefs(this);
					Log.d(TAG, "user & pass for login :" + username + "|"
							+ passwrd);
					if (!TextUtils.isEmpty(username)
							&& !TextUtils.isEmpty(passwrd)) {
						login = xmmpMan.performLogin(username, passwrd);
						if (login) {
							Log.d(TAG, "Login DOne by shared pref");
							xmmpMan.registerIncomingMessageListener();
							xmmpMan.registerIncomingPackateListener();
						} else {

							Intent intnt = new Intent();
							intnt.setAction("NotAbleToLoginInPSPChat");
							sendBroadcast(intnt);
							stopSelf();
						}
					} else {
						stopSelf();
					}
				}

				if (login) {
					Intent intnt = new Intent();
					intnt.setAction("LoginDoneInPSPChat");
					sendBroadcast(intnt);
				}

			} else {
				Log.d(TAG, "Not Connected with server");

				Intent intnt = new Intent();
				intnt.setAction("NoXmppInitInPSPChat");
				sendBroadcast(intnt);
				stopSelf();
			}
		} catch (Exception e) {
			e.printStackTrace();
			stopSelf();
		}
		return START_STICKY;
	}

}