package com.saini.testingchat.util;

import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.preference.PreferenceManager;

public class ChatUtils {
	public static boolean isNetworkAvailable(Context context) {
		ConnectivityManager connectivityManager = (ConnectivityManager) context
				.getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo activeNetworkInfo = connectivityManager
				.getActiveNetworkInfo();
		return activeNetworkInfo != null;
	}

	public static String getUserNameFromSharedPrefs(Context context) {
		SharedPreferences sharedpreferences = PreferenceManager
				.getDefaultSharedPreferences(context);
		return sharedpreferences.getString("user", "");
	}

	public static String getPasswordFromSharedPrefs(Context context) {
		SharedPreferences sharedpreferences = PreferenceManager
				.getDefaultSharedPreferences(context);
		return sharedpreferences.getString("pwd", "");
	}

	public static void setPasswordFromSharedPrefs(Context context, String pass) {
		SharedPreferences sharedpreferences = PreferenceManager
				.getDefaultSharedPreferences(context);
		Editor edit = sharedpreferences.edit();
		edit.putString("pwd", pass);
		edit.commit();
	}

	public static void setUserNameFromSharedPrefs(Context context, String user) {
		SharedPreferences sharedpreferences = PreferenceManager
				.getDefaultSharedPreferences(context);
		Editor edit = sharedpreferences.edit();
		edit.putString("user", user);
		edit.commit();
	}

	public static void clearSharedPrefs(Context context) {
		SharedPreferences sharedpreferences = PreferenceManager
				.getDefaultSharedPreferences(context);
		Editor edit = sharedpreferences.edit();
		edit.clear();
		edit.commit();
	}

}
